package com.fjhx.xmhjc.service.about.impl;

import cn.hutool.core.util.ObjectUtil;
import com.fjhx.file.entity.FileInfoVo;
import com.fjhx.file.utils.ObsFileUtil;
import com.fjhx.xmhjc.entity.about.po.AboutUsCulture;
import com.fjhx.xmhjc.entity.about.po.AboutUsHonor;
import com.fjhx.xmhjc.mapper.about.AboutUsHonorMapper;
import com.fjhx.xmhjc.service.about.AboutUsHonorService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.common.utils.wrapper.SqlField;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.about.vo.AboutUsHonorVo;
import com.fjhx.xmhjc.entity.about.dto.AboutUsHonorSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.xmhjc.entity.about.dto.AboutUsHonorDto;
import cn.hutool.core.bean.BeanUtil;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 关于我们-荣誉资质 服务实现类
 * </p>
 *
 * @author lqh
 * @since 2023-11-13
 */
@Service
public class AboutUsHonorServiceImpl extends ServiceImpl<AboutUsHonorMapper, AboutUsHonor> implements AboutUsHonorService {

    @Override
    public List<AboutUsHonorVo> getList(AboutUsHonorSelectDto dto) {
        IWrapper<AboutUsHonor> wrapper = getWrapper();
        wrapper.orderByDesc("auh", AboutUsHonor::getId);
        List<AboutUsHonorVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<AboutUsHonorVo> getPage(AboutUsHonorSelectDto dto) {

        IWrapper<AboutUsHonor> wrapper = getWrapper();
        wrapper.orderByAsc("auh", AboutUsHonor::getSort);
        wrapper.keyword(dto,new SqlField("auc", AboutUsHonor::getHonorName));
        Page<AboutUsHonorVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public AboutUsHonorVo detail(Long id) {
        AboutUsHonor AboutUsHonor = this.getById(id);
        AboutUsHonorVo result = BeanUtil.toBean(AboutUsHonor, AboutUsHonorVo.class);
        return result;
    }

    @Override
    public void add(AboutUsHonorDto aboutUsHonorDto) {
        this.save(aboutUsHonorDto);
        // 荣誉资质图片
        ObsFileUtil.saveFile(aboutUsHonorDto.getHonorCoverList(), aboutUsHonorDto.getId(), 1);

    }

    @Override
    public void edit(AboutUsHonorDto aboutUsHonorDto) {
        this.updateById(aboutUsHonorDto);
        // 荣誉资质图片
        ObsFileUtil.editFile(aboutUsHonorDto.getHonorCoverList(), aboutUsHonorDto.getId(), 1);

    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }


    @Override
    public List<AboutUsHonorVo> getListByOpen() {
        IWrapper<AboutUsHonor> wrapper = getWrapper();
        wrapper.eq(AboutUsHonor::getStatus,"1");
        wrapper.orderByAsc("auh", AboutUsHonor::getSort);
        List<AboutUsHonorVo> list = this.baseMapper.getList(wrapper);

        list.forEach(x->{
            //获取公众号图片
            List<Long> businessIdList = new ArrayList<>();
            businessIdList.add(x.getId());
            Map<Long, List<FileInfoVo>> fileMap = ObsFileUtil.getFileMap(businessIdList, 1);
            x.setHonorCoverList(fileMap.get(x.getId()));
        });

        return list;
    }
}
