package com.fjhx.xmhjc.service.product.impl;

import com.fjhx.xmhjc.entity.product.po.ProductImage;
import com.fjhx.xmhjc.mapper.product.ProductImageMapper;
import com.fjhx.xmhjc.service.product.ProductImageService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.product.vo.ProductImageVo;
import com.fjhx.xmhjc.entity.product.dto.ProductImageSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.xmhjc.entity.product.dto.ProductImageDto;
import cn.hutool.core.bean.BeanUtil;

import java.util.List;

/**
 * <p>
 * 产品图片 服务实现类
 * </p>
 *
 * @author hj
 * @since 2023-11-12
 */
@Service
public class ProductImageServiceImpl extends ServiceImpl<ProductImageMapper, ProductImage> implements ProductImageService {

    @Override
    public List<ProductImageVo> getList(ProductImageSelectDto dto) {
        IWrapper<ProductImage> wrapper = getWrapper();
        wrapper.orderByDesc("pi", ProductImage::getId);
        List<ProductImageVo> list = this.baseMapper.getList(wrapper);
        return list;
    }

    @Override
    public Page<ProductImageVo> getPage(ProductImageSelectDto dto) {
        IWrapper<ProductImage> wrapper = getWrapper();
        wrapper.orderByDesc("pi", ProductImage::getId);
        Page<ProductImageVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public ProductImageVo detail(Long id) {
        ProductImage ProductImage = this.getById(id);
        ProductImageVo result = BeanUtil.toBean(ProductImage, ProductImageVo.class);
        return result;
    }

    @Override
    public void add(ProductImageDto productImageDto) {
        this.save(productImageDto);
    }

    @Override
    public void edit(ProductImageDto productImageDto) {
        this.updateById(productImageDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

}
